# -*- coding: Latin-1 -*-
#
# SMM Share and Money Management
# Copyright (c) 2007-2010 Carsten Grohmann
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2 of the
# License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.

## \file smm/database.py
#
# Contains general database stuff
#
# \namespace smm::database
# Functions to create, open and close the database as well as the db
# schema and the initial data set.
#
# \author Carsten Grohmann <mail (at) carstengrohmann (dot) de>
#
# \par License:
# GPL version 2.0

# import project modules
from storm.locals import *

## Store object for high level %database acccess
store = None


## \brief Initialise the Storm ORM wrapper
#
#  \param uri Database URI
#  \see close_storm()
def init_storm(uri):
    global store
    database = create_database(uri)
    store    = Store(database)


## \brief Close the Storm ORM wrapper
#
#  All open changes will be written in the %database
#  \see init_storm()
def close_storm():
    global store
    if store:
        store.commit() 
        store.close() 
        store = None
